# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/99_arguments.ipynb.

# %% auto 0
__all__ = ['JsonType', 'parse_arg', 'parse_attrs']

# %% ../nbs/99_arguments.ipynb 3
import json
from typing import Union

# %% ../nbs/99_arguments.ipynb 6
JsonType = Union[None, int, str, bool, list["JsonType"], dict[str, "JsonType"]]


def parse_arg(arg: str) -> JsonType:
    """Parses a single arg in string format using json."""
    try:
        v: JsonType = json.loads(arg)
        return v
    except json.JSONDecodeError:
        return arg


def parse_attrs(attrs: dict[str, str]) -> dict[str, JsonType]:
    """Parses a dictonary of string into a dictonary of parsed values."""
    return {k: parse_arg(y) for k, y in attrs.items()}
